<template>
  <div>
    <v-autocomplete
      v-model="selectedLocation"
      :items="locations"
      :loading="loading"
      :search-input.sync="search"
      :menu-props="{ maxHeight: 200 }"
      :item-text="itemText"
      :item-value="itemValue"
      :label="label"
      :placeholder="placeholder"
      :readonly="false"
    />
  </div>
</template>
<script>
import api from '@/lib/axios';
export default {
  name: 'location-auto-complete',
  props: {
    value: {
      default: '',
    },
    label: {
      type: String,
      default: 'Location',
    },
    placeholder: {
      type: String,
      default: 'Search for a location',
    },
    itemText: {
      type: Function,
      default: (location) => location.address,
    },
    itemValue: {
      type: Function,
      default: (location) => location,
    },
  },
  data() {
    return {
      locations: [],
      loading: false,
      search: '',
    };
  },
  mounted() {
    if (this.value?.address) {
      this.search = this.value.address;
    }
  },
  watch: {
    search: {
      async handler() {
        const data = await this.fetchLocations();
        if (data && data.result) {
          const { result } = data;
          this.locations = result?.addresses || [];
        }
      },
    },
  },
  computed: {
    selectedLocation: {
      get() {
        return this.value;
      },
      set(newValue) {
        this.$emit('input', newValue);
      },
    },
  },
  methods: {
    async fetchLocations() {
      if (!this.search) {
        this.locations = [];
        return;
      }
      this.loading = true;
      try {
        const { data } = await api.get(
          `/common-master/osrm/googleadress?q=${this.search}`
        );
        return data;
      } catch (error) {
        console.error(error);
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>
